﻿package
{
	import de.popforge.audio.output.Audio;
	import de.popforge.audio.output.Sample;
	import de.popforge.audio.output.SoundFactory;
	
	import flash.display.Sprite;
	import flash.media.Sound;
	import flash.utils.ByteArray
	import flash.events.MouseEvent
	import flash.display.StageScaleMode
	
	/**
	 * Example CreateASound
	 * Creates one second of dynamic audio and converts it to a flash.media.Sound object
	 * 
	 * @author Andre Michelle
	 */
	[SWF( backgroundColor='0x333333', frameRate='40', width='700', height='320')]

	public class CreateASound_Key extends Sprite
	{
			
		private var sound:Sound;
		private var waveViewer:WaveViewer 
		
		//初期値はド　220Hzに設定
		private var frequency:Number = 220
		
		
		public function CreateASound_Key()
		{
			this.stage.scaleMode = StageScaleMode.NO_SCALE
			//波形ビューの生成
			waveViewer = new WaveViewer(this, -400, 180,0xaaffee)
			//ボタン生成
			addBtn();
		}
		

		private function createSound():void {
						
			//-- Create Array to store Samples
			var samples: Array = new Array();
			
			//-- some locals
			var sample: Sample;
			var amplitude: Number;
			var phase: Number = 0;
			
			
			//-- CREATE ONE SECOND OF AUDIO (SINUS WAVE)
			for( var i: int = 0 ; i < 44100 ; i++ )
			{
				//-- create an amplitude [-1,1]
				amplitude = Math.sin( phase * Math.PI)*1;
				
				//-- create a sample
				sample = new Sample( amplitude, amplitude );
				
				//-- push in array
				samples.push( sample );
							
				//-- increase phase
				phase += frequency / Audio.RATE44100;
			}
			waveViewer.buildWaveFromLeft(samples,1,0.1,100)		

			//-- create a Sound object from samples array
			SoundFactory.fromArray( samples, Audio.STEREO, Audio.BIT16, Audio.RATE44100, onSoundGenerated );

			
		}
		private function onSoundGenerated( sound: Sound ): void
		{

			this.sound = sound
			//-- play the shit
			sound.play();
		}
		private function addBtn():void {
			for (var i:int = 0; i < 8;i++){
				var sprite:Sprite = new Sprite
				//ボタンのグラデーション
				var color:uint = (220-i*20) << 16 | (255-10*i) <<8 | (220-i*5) 
				sprite.graphics.lineStyle(1)
				sprite.graphics.beginFill(color)
				sprite.graphics.drawRect((5+55*i), 10, 30, 30)
				sprite.graphics.endFill()
				addChildAt(sprite,i)
				sprite.addEventListener(MouseEvent.CLICK, onClick)				
				sprite.buttonMode = true
			}
		}
		private function onClick(e:MouseEvent):void {
			sound = null
			var id:int = getChildIndex(Sprite(e.target) );
			setKey(id)
		}
		private function setKey(id:int):void {
			switch(id) {
				case 0://ド
					frequency = 220
					break
				case 1://レ
					frequency = 246.942
					break
				case 2://ミ
					frequency = 277.183
					break
				case 3://ファ
					frequency = 293.665
					break
				case 4://ソ
					frequency = 329.628
					break
				case 5://ラ
					frequency = 369.994
					break
				case 6://シ
					frequency = 415.305
					break
				case 7://ド
					frequency = 440
					break
				default:
					frequency = 220
			}
			createSound()
		}
	}
}