package
{
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.display.DisplayObjectContainer;
	
	public class WaveViewer extends Sprite
	{
		private var wave:Shape;
		private var lineColor:uint
		
		function WaveViewer(target:DisplayObjectContainer,x:int,y:int,lineColor:uint=0)
		{
			this.lineColor = lineColor
			target.addChild(this)
			wave = new Shape()
			initWave(x,y)
		}	
			

		private function initWave(x:int,y:int):void
		{
			graphics.lineStyle(1,0xFF0000)
			graphics.lineTo(2000,0)
			addChild(wave)
			this.y=y	
			this.x=x
			wave.graphics.lineStyle(1,0x0)	
		}
		public function buildWave(arr:Array,interval:int=1,rateX:Number=0.1,rateY:Number=100):void
		{	
			for (var i:int=0; i<arr.length-interval ;i += interval){
				drawWave(i,arr[i],rateX,rateY)
			}			
		}
		public function buildWaveFromLeft(arr:Array,interval:int=1,rateX:Number=0.1,rateY:Number=100):void
		{	
			clearWave()
			for (var i:int=0; i<arr.length-interval ;i += interval){
				drawWave(i,arr[i].left,rateX,rateY)
			}			
		}
		public function drawWave(x:Number,y:Number,rateX:Number=0.1,rateY:Number=100):void
		{
			wave.graphics.lineStyle(1,lineColor)
			x=x*rateX;
			y=y*rateY;
			wave.graphics.lineTo(x,y)
			wave.graphics.moveTo(x,y)
		}
		public function clearWave():void
		{
			wave.graphics.clear()
		}	
	}
}